import 'dart:async';

import 'package:flutter_base_loader/plugins/base_info.dart';

class baseLoading {
  Completer<void> _com = Completer<void>();
  Completer<void> _comLoadingPage = Completer<void>();
  factory baseLoading() => _instance;
  static final baseLoading _instance = baseLoading._internal();
  late Future<void> _future;
  late Future<void> _futureReady;

  baseLoading._internal() {
    //1、wait loadingPage initState
    //2、init baseInfo
    //3、init userInfo
    _futureReady = _comLoadingPage.future.then((_) => baseInfo.init());
    _future = _futureReady.then((value) => _com.future);
  }
  static baseLoading get instance => _instance;

  Future<void> get future => _future;
  Future<void> get onReady => _futureReady;

  void pageReady() {
    if (!_comLoadingPage.isCompleted) _comLoadingPage.complete();
  }

  void complete() {
    if (!_com.isCompleted) _com.complete();
  }

  void completeError(Object error) {
    if (!_com.isCompleted) _com.completeError(error);
  }
}
